#include <gtk/gtk.h>
#include "history.h"

// owns the data
gchar *history_pop (GSList **hist) {
	if (!hist || !*hist) return NULL; // empty history
	gchar *ret = (*hist)->data;
	*hist = g_slist_delete_link (*hist, *hist);
	//g_print("history popped: %s\n", ret);	
	return ret;
}

// owns the data
gchar *history_peek (GSList **hist) {
	if (!hist || !*hist) return NULL; // empty history
	gchar *ret = g_strdup((*hist)->data);
	//g_print("history peeked: %s\n", ret);	
	return ret;
}

// original data can be destroyed
void history_push (GSList **hist, gchar *url) {
	if (!url) return; // ignore empty url
	if (hist && *hist) {
		// don't push if it is already identical with top of stack
		if (strcmp( (*hist)->data, url ) == 0) return;
	}
	*hist = g_slist_prepend(*hist, g_strdup(url));
	//g_print("history added: %s\n", url);
}

void history_clear (GSList **hist) {
	if (!hist || !*hist) return; // empty history
	g_slist_free_full (*hist, g_free);
	*hist = NULL;
	//g_print("history cleared\n");
}
