/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
   Copyright (C) 2006 Chris Lord <chris@openedhand.com>
   
   derived from dom-styleevent.h,

   Copyright (C) 2000 CodeFactory AB
   Copyright (C) 2000 Jonas Borgstr\366m <jonas@codefactory.se>
   Copyright (C) 2000 Anders Carlsson <andersca@codefactory.se>
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __DOM_ATTR_EVENT_H__
#define __DOM_ATTR_EVENT_H__

typedef struct _DomAttrEvent DomAttrEvent;
typedef struct _DomAttrEventClass DomAttrEventClass;

#include <glib-object.h>

#include <dom/core/dom-node.h>
#include <dom/events/dom-event.h>

#define DOM_TYPE_ATTR_EVENT             (dom_attr_event_get_type ())
#define DOM_ATTR_EVENT(object)          (G_TYPE_CHECK_INSTANCE_CAST ((object), DOM_TYPE_ATTR_EVENT, DomAttrEvent))
#define DOM_ATTR_EVENT_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), DOM_TYPE_ATTR_EVENT, DomAttrEventClass))
#define DOM_IS_ATTR_EVENT(object)       (G_TYPE_CHECK_INSTANCE_TYPE ((object),  DOM_TYPE_ATTR_EVENT))
#define DOM_IS_ATTR_EVENT_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), DOM_TYPE_ATTR_EVENT))
#define DOM_ATTR_EVENT_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), DOM_TYPE_ATTR_EVENT, DomAttrEventClass))

struct _DomAttrEvent {
	DomEvent parent;

	DomString *attrName;
	gushort attrChange;
	DomString *prevValue;
	DomString *newValue;
	DomNode *relatedNode;
};

struct _DomAttrEventClass {
	DomEventClass parent_class;
};

enum {
	DOM_ATTR_CHANGE_MODIFIED,
	DOM_ATTR_CHANGE_ADDED,
	DOM_ATTR_CHANGE_REMOVED
};

GType dom_attr_event_get_type (void);

const DomString *dom_AttrEvent__get_attrName (DomAttrEvent *event);
gushort dom_AttrEvent__get_attrChange (DomAttrEvent *event);
const DomString *dom_AttrEvent__get_prevValue (DomAttrEvent *event);
const DomString *dom_AttrEvent__get_newValue (DomAttrEvent *event);
DomNode *dom_AttrEvent__get_relatedNode (DomAttrEvent *event);

void dom_AttrEvent_initAttrEvent (DomAttrEvent *event, const DomString *typeArg, DomBoolean canBubbleArg, DomBoolean cancelableArg, const DomString *attrNameArg, gushort attrChangeArg, const DomString *prevValueArg, const DomString *newValueArg, DomNode *relatedNodeArg);

#endif /* __DOM_ATTR_EVENT_H__ */
