#ifndef URL_UTILS_H
#define URL_UTILS_H

typedef struct _URL {
	gchar *proto;
	gchar *host;
	gchar *user;
	gchar *pass;
	gchar *path;
	gchar *query;
	gchar *anchor;
} URL;

URL* url_new();
void url_free(URL *u);
URL* url_copy(URL *u);

URL* str_to_url(const gchar *url);
gchar *url_to_str(URL* url);
gchar *url_make_canonical(const gchar* path);
URL* url_set_relative (URL *base, const gchar *new_url);

gchar *url_get_proto(const gchar *url);
gchar *url_get_host_with_user_pass(const gchar *url);
gchar *url_get_host(const gchar *url);
gchar *url_get_user(const gchar *url);
gchar *url_get_pass(const gchar *url);
gchar *url_get_path(const gchar * url);
gchar *url_get_query(const gchar *url);
gchar *url_get_anchor(const gchar *url);


#endif
